/*
ICF3-V 2018N125
GF(2^128)̏Z̃TvR[h

Intel White Paper
Carry-Less Multiplication Instruction and its Usage for Computing the GCM Mode
323640-001 Revision 2.0 May 2010
ɂ OpenSolaris ggfmulh C Function CR[hŏꂽ
gfmul()֐ƌ݊Ȋ֐ɂȂĂ܂

ICF3-V̉ZXOR̉Zł悤ɕύX̃n[hEFAłB
\tgEFA32bit̃L[XZɂ̂łB
n[hEFA̓ނ͐SzȂƎv܂A\tgEFA̓ނ
Ă܂B32bit̃L[XZgȒPȎ
v̂ŁAقǐSzȂ悤ɎvĂ܂AQl܂ŁB

*/

#include <stdio.h>
#include <stdint.h>

uint32_t R[16];
uint32_t A,B,C,D,W;

// BC = A x C + B
void clmul() {
    uint32_t i,CF,ADD;
    const uint32_t CY = 0;
    CF = 0; // ADDL=A ; A=ADD
    D = C;
    C = C<<1|CF; D=D>>31; // D=W0
    for(i=0 ; i<32 ; i++) {
        if(C&1) ADD = A^B;
        else ADD = B;
        C = ADD<<31 | C>>1;
        B = CY<<31 | ADD>>1;
    }
    if(D) B^=A; // TESTD & ZF
}

void reduction() {
    const uint32_t CY = 0;
    uint32_t ADD;
    B = C = 0;
    ADD=A^B; B=CY<<31|ADD>>1; C=ADD<<31|C>>1; 
    ADD=B; C=ADD<<31|C>>1; B=CY<<31|ADD>>1;
    ADD=B; C=ADD<<31|C>>1; B=CY<<31|ADD>>1;
    ADD=B; C=ADD<<31|C>>1; B=CY<<31|ADD>>1;
    ADD=B; C=ADD<<31|C>>1; B=CY<<31|ADD>>1;
    ADD=A^B; B=CY<<31|ADD>>1; C=ADD<<31|C>>1; 
    ADD=A^B; B=CY<<31|ADD>>1; C=ADD<<31|C>>1; 
    ADD=A^B; B=ADD;
}

void gfmul_i3v(uint32_t *x,uint32_t *y, uint64_t *r) {
    int i;
    union {
        uint64_t d[2];
        uint32_t q[4];
    } res;

    for(i=0 ; i<4 ; i++) R[i+0] = x[i];
    for(i=0 ; i<4 ; i++) R[i+4] = y[i];

    /**************************/
    /* R0-R3 x R4-R7 -> R8-R15*/
    /**************************/

    B = 0;

    /* 0: R0 x R4 */
    A = R[0];
    C = R[4];
    clmul(); // BC = A x C + B
    W = C;
    R[8] = W;

    /* 1: R0 x R5 */
    A = R[0];
    C = R[5];
    clmul(); // BC = A x C + B
    R[15] = B;
    B = C;

    /* 1: R1 x R4 */
    A = R[1];
    C = R[4];
    clmul(); // BC = A x C + B
    W = C;
    R[9] = W;
    D = R[15];
    B = B ^ D;

    /* 2: R0 x R6 */
    A = R[0];
    C = R[6];
    clmul(); // BC = A x C + B
    R[15] = B;
    B = C;

    /* 2: R1 x R5 */
    A = R[1];
    C = R[5];
    clmul(); // BC = A x C + B
    D = R[15];
    R[15] = D ^ B;
    B = C;

    /* 2: R2 x R4 */
    A = R[2];
    C = R[4];
    clmul(); // BC = A x C + B
    W = C;
    R[10] = W;
    D = R[15];
    B = B ^ D;

    /* 3: R0 x R7 */
    A = R[0];
    C = R[7];
    clmul(); // BC = A x C + B
    R[15] = B;
    B = C;

    /* 3: R1 x R6 */
    A = R[1];
    C = R[6];
    clmul(); // BC = A x C + B
    D = R[15];
    R[15] = D ^ B;
    B = C;

    /* 3: R2 x R5 */
    A = R[2];
    C = R[5];
    clmul(); // BC = A x C + B
    D = R[15];
    R[15] = D ^ B;
    B = C;

    /* 3: R3 x R4 */
    A = R[3];
    C = R[4];
    clmul(); // BC = A x C + B
    W = C;
    R[11] = W;
    D = R[15];
    B = B ^ D;

    /* 4: R1 x R7 */
    A = R[1];
    C = R[7];
    clmul(); // BC = A x C + B
    R[15] = B;
    B = C;

    /* 4: R2 x R6 */
    A = R[2];
    C = R[6];
    clmul(); // BC = A x C + B
    D = R[15];
    R[15] = D ^ B;
    B = C;

    /* 4: R3 x R5 */
    A = R[3];
    C = R[5];
    clmul(); // BC = A x C + B
    W = C;
    R[12] = W;
    D = R[15];
    B = B ^ D;

    /* 5: R2 x R7 */
    A = R[2];
    C = R[7];
    clmul(); // BC = A x C + B
    R[15] = B;
    B = C;
    
    /* 5: R3 x R6 */
    A = R[3];
    C = R[6];
    clmul(); // BC = A x C + B
    W = C;
    R[13] = W;
    D = R[15];
    B = B ^ D;

    /* 6: R3 x R7 */
    A = R[3];
    C = R[7];
    clmul(); // BC = A x C + B
    R[14] = C;
    R[15] = B;


    /* reduction R8 */
    A = R[8];
    reduction();

    A = R[11];
    W = C ^ A;
    R[11] = W;

    A = R[12];
    W = B ^ A;
    R[12] = W;

    /* reduction R9 */
    A = R[9];
    reduction();

    A = R[12];
    W = C ^ A;
    R[12] = W;

    A = R[13];
    W = B ^ A;
    R[13] = W;

    /* reduction R10 */
    A = R[10];
    reduction();

    A = R[13];
    W = C ^ A;
    R[13] = W;

    A = R[14];
    W = B ^ A;
    R[14] = W;

    /* reduction R11 */
    A = R[11];
    reduction();

    A = R[14];
    W = C ^ A;
    R[14] = W;

    A = R[15];
    W = B ^ A;
    R[15] = W;

    res.q[0] = R[12];
    res.q[1] = R[13];
    res.q[2] = R[14];
    res.q[3] = R[15];

    r[0] = res.d[0];
    r[1] = res.d[1];

}

int main(int argc,char* argv[]) {
    uint64_t r[2];
    uint32_t x[4],y[4];

    x[0] = 0x12345678;
    x[1] = 0x23456789;
    x[2] = 0x3456789A;
    x[3] = 0x456789AB;

    y[0] = 0xFEDCBA98;
    y[1] = 0xEDCBA987;
    y[2] = 0xDCBA9876;
    y[3] = 0xCBA98765;

    gfmul_i3v(x,y,r);
    printf("%016llX %016llX\n",r[0],r[1]);

    /* B44CDC3F1FA9B0E1 47E4A4C66CF60887 */
    return 0;
}

